#ifndef _HAPLOTYPETEST_PARAMETERS_
#define _HAPLOTYPETEST_PARAMETERS_

/* Buffer size */
#define MAX_BUFFER_LENGTH      2048    /* Input buffer size for option */
#define MAX_RECORD_LENGTH      40960   /* Input buffer size for genotype file */
#define MESSAGE_BUFF_SIZE      128     /* Error message buffer */
#define HAPLOTYPE_BLOCK_SIZE   1024000 /* Haplotype list block size */
#define TEMP_BLOCK_SIZE        1024

/* Genotype size */
#define MAX_NUMBER_OF_LOCI     32 /* Size of int */
#define MAX_NUMBER_OF_ALLELE   2  /* SNPs */
#define MAX_LOCI_REGION        32 /* Maximum number of loci to divide region */
#define MAX_LOCI_OVERLAP       5  /* Maximum number of overlapped loci */

/* Macros for input data */
#define COMMENT_CHAR           '#'
#define LINE_FEED              '\n'
#define CARRIAGE_RETURN        '\r'
#define DELIMITER_SPACE        ' '
#define DELIMITER_TAB          '\t'
#define STRING_TERMINATOR      '\0'
#define MISSING_DATA_NAME      "*"
#define MISSING_DATA_CODE      2
#define MAX_INPUT_ALLELE       16
#define ALLELE_CODE_MASK       0x0f
#define ALLELE_CODE_SHIFT      4
#define PREFILE_IGNORE_COUNT   6
#define PREFILE_PHENOTYPE      5
#define ORIGINAL_IGNORE_COUNT  2
#define ORIGINAL_PHENOTYPE     1
#define ORIGINAL_ALLELE_DELM   '/'
#define CHAR_IN_ALLELE_NAME    3
#define NULL_ALLELE_NAME       "   "
#define CHAR_IN_SUBJECT_NAME   10
#define TARGET_LOCI_DELM       '-'

/* Parameters for estimation */
#define FILTERED_LOCUS         -1
#define NO_ASSOCIATION_MODEL   0
#define DOMINANT_MODEL         1
#define RECESSIVE_MODEL        2
#define GENOTYPE_MODEL         3
#define OVER_DOMINANT_MODEL    4

/* Default parameters */
#define CRITERIA               1.00001
#define CRITERIA_FREQ          0.00001
#define CRITERIA_CONF          0.00001
#define MIN_FREQUENCY          5.0e-5
#define ACCURACY               1.0e-12
#define SIGNIFICANCE           0.05
#define CONFIDENCE             0.95
#define SNP_REJECTION          0.0
#define CUT_FREQUENCY          -0.1
#define WINDOW_SIZE            9

#define RANDOM_SEED            0

/*
#define PI                     3.1415926535
*/
#define PI                     M_PI

#endif
