#include "haplotypetest.h"

/* Utility function */
extern void          *mem_alloc(size_t, const char *);
extern void           hpsort_reverse_index_of_double_array(int, double *, unsigned int *);
extern void           hpsort_index_of_double_array(int, double *, unsigned int *);

/* Error handler */
extern int            error_check();
extern int            error_message(char *);
extern int            warning_message(char *);

/* Define functions */
double         odds_ratio_by_penetrance(Estimate_Set *);

double         odds_ratio_by_penetrance(Estimate_Set *table)
{
  /* Local variables */
  double    odds_ratio, p_plus, p_minus, c_plus, c_minus;
  double    odds_by_table;

  if (table->model_type == GENOTYPE_MODEL) {
    odds_ratio = -1.0;
  }
  else {
    p_plus  = table->p_plus[1];
    p_minus = table->p_plus[0];
    c_plus  = 1.0 - p_plus;
    c_minus = 1.0 - p_minus;
    if ((c_plus > 0.0) && (p_minus > 0.0)) {
      odds_ratio = p_plus / c_plus * c_minus / p_minus;
    }
    else {
      odds_ratio = -1.0;
    }
  }
  /*  printf("odds ratio = %e %f (for model type %d)\n",odds_ratio,odds_ratio,model_type);*/

  return odds_ratio;
}
